<?php
/*
Plugin Name: LPS Payment Gateway (HPS)
Plugin URI: http://www.lateralpaymentsolutions.com/cms/plugins
Description: Plugin to integrate with Lateral Payment Solutions (UK) payment gateway based on HPS model. For more information contact info@lpsmail.com
Version: 4.0.7
Author: Latpay
Author URI: http://www.digisource.co.in 
*/
add_action('plugins_loaded', 'woocommerce_gateway_latpay_init', 0);
function woocommerce_gateway_latpay_init() {
	if ( !class_exists( 'WC_Payment_Gateway' ) ) return;
	class WC_Gateway_Latpay extends WC_Payment_Gateway {
		public function __construct(){
			$this->id 					= 'latpay'; 
			$this->method_title 		= 'Latpay';
			$this->method_description	= 'Lateral Payment Solutions'; 
			$this -> has_fields = false;
			$this -> init_form_fields();
			$this -> init_settings();
			$this -> title = $this -> settings['title'];
			$this -> description = $this -> settings['description'];
			$this -> Merchant_User_Id = $this -> settings['Merchant_User_Id'];
			$this -> merchantpwd = $this -> settings['merchantpwd'];
			$this -> process_url = $this -> settings['process_url'];
			$this -> Purchase_summary = $this -> settings['Purchase_summary'];
			$this -> salt = $this -> settings['salt'];
			$this -> redirect_page_id = $this -> settings['redirect_page_id'];
			$this->icon = apply_filters( 'woocommerce_simplepay_icon', plugins_url( '/images/logo.png' , __FILE__ ) );
			$this -> msg['message'] = "";
			$this -> msg['class'] = "";
      $this->supports = array( 'subscriptions', 'products' );
			//add_action('init', array(&$this, 'check_latpay_response'));
            //add_action('woocommerce_api_' . strtolower(get_class($this)), array($this, 'check_latpay_response'));
			add_action('woocommerce_api_' . strtolower(get_class($this)), array($this, 'callback_handler'));
            //update for woocommerce >2.0
			if ( version_compare(WOOCOMMERCE_VERSION, '2.0.0', '>=' ) ) {
                    add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( &$this, 'process_admin_options' ) ); //update for woocommerce >2.0
              } else {
                    add_action( 'woocommerce_update_options_payment_gateways', array( &$this, 'process_admin_options' ) ); // WC-1.6.6
              }
              add_action('woocommerce_receipt_latpay', array(&$this, 'receipt_page'));	
        } 
        function init_form_fields(){
           $this -> form_fields = array(
                'enabled' => array(
                     'title' => __('Enable/Disable', 'latpay'),
                     'type' => 'checkbox',
                     'label' => __('Enable LPS Payment Module.', 'latpay'),
                     'default' => 'no'),
                'title' => array(
                     'title' => __('Title:', 'latpay'),
                     'type'=> 'text',
                     'description' => __(' ', 'latpay'),
                     'default' => __('latpay', 'latpay')),
                'description' => array(
                     'title' => __('Description:', 'latpay'),
                     'type' => 'textarea',
                     'description' => __('This controls the description which the user sees during checkout.', 'lps'),
                     'default' => __(' ', 'latpay')),
                'Merchant_User_Id' => array(
                     'title' => __('Merchant ID', 'latpay'),
                     'type' => 'text',
                     'description' => __(' ')),
                'merchantpwd' => array(
                     'title' => __('Merchant Password', 'latpay'),
                     'type' => 'text',
                     'description' => __(' ')),
                'salt' => array(
                     'title' => __('Secret Key', 'latpay'),
                     'type' => 'text',
                     'description' =>  __('', 'latpay'),	
               ),  
                'Purchase_summary' => array(
                     'title' => __('Purchase summary', 'latpay'),
                     'type' => 'text',
                     'description' =>  __('', 'latpay'),	
               ),  
                'process_url' => array(
                     'title' => __('Gateway url', 'latpay'),
                     'type' => 'text',
                     'description' =>  __('', 'latpay'),	)
          );
     }  
     public function admin_options(){
           echo '<h3>'.__('paylps Payment Gateway', 'lpsnew').'</h3>';
           echo '<p>'.__('LPS is most popular payment gateway for online shopping').'</p>';
           echo '<table class="form-table">';
           $this -> generate_settings_html();
           echo '</table>';
     } 
     function payment_fields(){
           if( $this->description ) {
                echo wpautop( wptexturize( $this->description ) );
          }
    } 
    function receipt_page($order){
     echo '<p><strong>' . __('Thank you for your order.', 'latpay').'</strong><br/>' . __('The payment page will open soon.', 'latpay').'</p>';
     echo $this->generate_latpay_form($order);
} 
function generate_latpay_form($order_id){
     global $woocommerce;
     $order = new WC_Order( $order_id );
     if ( '' == $this->redirect_page  || 0 == $this->redirect_page ) {
          $redirect_url = get_site_url() . "/";
    } else {
          $redirect_url = get_permalink( $this->redirect_page );
    }
    if ( version_compare(WOOCOMMERCE_VERSION, '2.0.0', '>=' ) ) {
          $redirect_url = add_query_arg( 'wc-api', get_class( $this ), $redirect_url );
    }
    $currencydesc = $order->order_currency;     
    $merchant_ref_number = trim($order_id);
    $amount = $order->order_total;           
    $salt =$this ->salt;    
    $ds=$this -> process_url;
    $str =sha1($currencydesc.$amount.$merchant_ref_number.$salt);
    $latpay_args = array(
          'Merchant_User_Id' => $this ->Merchant_User_Id, 
          'merchantpwd' => $this ->merchantpwd,
          'Purchase_summary' => $this ->Purchase_summary,
          'currencydesc' =>$order->order_currency,
          'merchant_ref_number' =>$merchant_ref_number,
          'customer_ipaddress' =>$customer_ipaddress,
          'amount' => $order -> order_total,
			//  'productinfo' => $productinfo,
          'customer_firstname' => $order -> billing_first_name,
          'customer_lastname' => $order -> billing_last_name,
          'customer_phone' => $order -> billing_phone,
          'customer_email' => $order -> billing_email, 
          'bill_firstname' => $order -> billing_first_name,
          'bill_lastname' => $order -> billing_last_name,
          'bill_address1' => $order -> billing_address_1,
          'bill_address2' => $order -> billing_address_2,
          'bill_city' => $order -> billing_city,
          'bill_state' => $order -> billing_state,
          'bill_country' => $order -> billing_country,
          'bill_zip' => $order -> billing_postcode,
          'ship_to_address1' => $order -> billing_address_1,
          'ship_to_address2' => $order -> billing_address_2,
          'ship_to_city' => $order -> billing_city,
          'ship_to_country' => $order -> billing_country,
          'ship_to_phone' => $order -> billing_phone,
          'ship_to_state' => $order -> billing_state,
          'ship_to_zip' => $order -> billing_zip,
          'transactionkey' => $str
    );
    $latpay_args_array = array();
    foreach($latpay_args as $key => $value){
          $latpay_args_array[] = "<input type='hidden' name='$key' value='$value'/>";
    }
    return '	<form action="'.$this->process_url.'" method="post" id="latpay_payment_form">
    ' . implode('', $latpay_args_array) . '
    <input type="submit" class="button-alt" id="submit_latpay_payment_form" value="'.__('Pay via Latpay', 'latpay').'" /> <a class="button cancel" href="'.$order->get_cancel_order_url().'">'.__('Cancel order &amp; restore cart', 'latpay').'</a>
    <script type="text/javascript">
    jQuery(function(){
          jQuery("body").block({
               message: "'.__('Thank you for your order. We are now redirecting you to Payment Gateway to make payment.', 'latpay').'",
               overlayCSS: {
                    background		: "#fff",
                    opacity			: 0.6
                    },
                    css: {
                         padding			: 20,
                         textAlign		: "center",
                         color			: "#555",
                         border			: "3px solid #aaa",
                         backgroundColor	: "#fff",
                         cursor			: "wait",
                         lineHeight		: "32px"
                   }
                   });
                   jQuery("#submit_latpay_payment_form").click();});
                   </script>
                   </form>';		
             }  
             function process_payment($order_id){
              global $woocommerce;
              $order = new WC_Order($order_id);
              if ( version_compare( WOOCOMMERCE_VERSION, '2.1.0', '>=' ) ) { 
                   $checkout_payment_url = $order->get_checkout_payment_url( true );
             } else {
                   $checkout_payment_url = get_permalink( get_option ( 'woocommerce_pay_page_id' ) );
             }
             return array(
                   'result' => 'success', 
                   'redirect' => add_query_arg(
                        'order', 
                        $order->id, 
                        add_query_arg(
                             'key', 
                             $order->order_key, 
                             $checkout_payment_url						
                       )
                  )
             );
       } 
       function latpay_get_pages($title = false, $indent = true) {
        $wp_pages = get_pages('sort_column=menu_order');
        $page_list = array();
        if ($title) $page_list[] = $title;
        foreach ($wp_pages as $page) {
             $prefix = '';
             if ($indent) {
                  $has_parent = $page->post_parent;
                  while($has_parent) {
                       $prefix .=  ' - ';
                       $next_page = get_post($has_parent);
                       $has_parent = $next_page->post_parent;
                 }
           }
           $page_list[$page->ID] = $prefix . $page->post_title;
     }
     return $page_list;
}  
function callback_handler() 
{
    if($_POST)
    {
       
     $Status = $_POST["Status"];
     $Transactionid = $_POST["Transactionid"];
     
     if (strlen($_POST["Merchant_ref_number"]) > 0)
     {
      $order_id = $Merchant_ref_number = $_POST["Merchant_ref_number"];
}
else
{
      $order_id = $Merchant_ref_number = $_POST["merchant_ref_number"];
}

$order = new WC_Order($order_id);
$order_data = $order->get_data();
$order_status = $order_data['status'];
if($order_status=="processing"){
   global $woocommerce;
   $order_key = $order->order_key;
   $url = site_url()."/order-received/thank-you/?key=".$order_key."&order_id=".$order_id;
   wp_redirect( $url );
   exit;
}                                            
else if($Status=='00'&& $order_status!="processing")  
{
      global $woocommerce;
      $result['result'] = 'success';
      $messgae_display = $Transactionid;
      $stat= $order->get_status();
      $order->update_status('processing', 'Success');
                                                      //Reduce stock levels
      wc_reduce_stock_levels( $order_id );
                                                //Remove cart
      WC()->cart->empty_cart();
      $order = wc_get_order($order_id);
      $order_key = $order->get_order_key();
      return array(
       'result' => 'success',
       'redirect' => $this->get_return_url( $order )
 );
}
else if($Status=='05')   
{
      $result['result'] = 'denied';
      $order->update_status('Pending payment', "Payment Declined");
      $curl = home_url('/checkout');
      wp_redirect($curl);
      exit();
}
else if($Status=='90')   
{
      $result['result'] = 'Communication Failure ';
      $order->update_status('On-Hold', "Communication Failure-Check With Latpay");
}
else
{
      $order->update_status('On-Hold', "Payment on hold");
}
}  
wp_die();
}
}  
} 
function woocommerce_add_gateway_latpay_gateway($methods) {
    $methods[] = 'WC_Gateway_Latpay';
    return $methods;
}
add_filter('woocommerce_payment_gateways', 'woocommerce_add_gateway_latpay_gateway' );
/* Use this code your process url and cancel url page*/
/* function lps_response_shotcode(){
 if($_POST){
							$Status = $_POST["Status"];
							$Transactionid = $_POST["Transactionid"];
							$order_id = $Merchant_ref_number = $_POST["Merchant_ref_number"];
							 if((int)$order_id>0){$order = new WC_Order($order_id);
								if($Status=='00')	{$result['result'] = 'success';
									$messgae_display = $Transactionid;	
									if($order->post_status=="wc-completed"){$order->update_status('onhold', "Waiting for Payment Response");
										$order->update_status('completed', $messgae_display);
									}else{$order->update_status('completed', $messgae_display);}}
								elseif($Status=='05')	{	$result['result'] = 'success';
								 $messgae_display = $Transactionid; if($order->post_status=="wc-completed"){$order->update_status('onhold', "Waiting for Payment Response");
										$order->update_status('completed', $messgae_display);}else{
										$order->update_status('completed', $messgae_display);}
								}else{$messgae_display = 'Your order was cancelled error code : '.$Status;
									if($order->post_status=="wc-pending"){$order->update_status('onhold', "Waiting for Payment Response");
										$order->update_status('pending', $messgae_display); }else{$order->update_status('pending', $messgae_display); }	}echo $woocommerce_class; 
				echo $messgae_display;	if($result['result']=="success"){	}}  }}
				add_shortcode('Transactionid', 'lps_response_shotcode');  } */
